--------------------------------------------------------------------------------
-- Goto: Tomb by Holzchopf
-- v1.3 - 28 Sep 2011	- Updated hierarchy
-- v1.2 - 30 Jul 2010	- It's no longer possible to teleport underwater
--						- Place indicator graphics have been improved
-- v1.1 - 26 Jul 2010	- Place indicator no longer appears after usage
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.gototomb={}
holzchopf.gototomb.target=0
holzchopf.gototomb.keyup=1

-- load ressources
holzchopf.gototomb.gfx_icn=loadgfx("holzchopf/gototomb.png")
setmidhandle(holzchopf.gototomb.gfx_icn)
holzchopf.gototomb.sfx_att=loadsfx("teleport.wav")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.gototomb.id=addweapon("holzchopf.gototomb","Goto: Tomb",holzchopf.gototomb.gfx_icn,0,3)

function holzchopf.gototomb.draw()
	-- choose position
	if weapon_shots<=1 then
		if weapon_shots==0 then
			holzchopf.gototomb.target=0
			weapon_shots=1
		end
		hudinfo("Press [up] and [down] to choose place, [fire] to teleport")
		if holzchopf.gototomb.keyup==1 then
			target=nil
			-- change target
			if keydown(key_up)==1 then
				-- find next place
				players=playertable(1,1)
				for i=1,#players,1 do
					id=players[i]
					if getplayerhealth(id)<=0 and getplayery(id)<getwatery()-30 then
						if target==nil then target=id end
						if id>holzchopf.gototomb.target then
							target=id
							break
						end
					end
				end
			elseif keydown(key_down)==1 then
				-- find prev place
				players=playertable(1,1)
				for i=#players,1,-1 do
					id=players[i]
					if getplayerhealth(id)<=0 and getplayery(id)<getwatery()-30 then
						if target==nil then target=id end
						if id<holzchopf.gototomb.target then
							target=id
							break
						end
					end
				end
			end
			if target~=nil then
				holzchopf.gototomb.keyup=0
				holzchopf.gototomb.target=target
				x=getplayerx(holzchopf.gototomb.target)
				y=getplayery(holzchopf.gototomb.target)
				scroll(x,y)
			end
		else
			if keydown(key_up)==0 and keydown(key_down)==0 then
				holzchopf.gototomb.keyup=1
			end
		end
		-- indicate position
		if holzchopf.gototomb.target>0 then
			x=getplayerx(holzchopf.gototomb.target)
			y=getplayery(holzchopf.gototomb.target)
			rot=-weapon_timer*0.3
			particle(p_lightpuff,x+math.cos(rot)*10,y-math.sin(rot)*10)
			particlespeed(math.cos(rot)*0.5,-math.sin(rot)*0.5)
			particlesize(5,5)
			particlecolor(0,0,255)
			particlealpha(1.0)
			particlefadealpha(0.05)
			weapon_timer=weapon_timer+1
		end
	end
end

function holzchopf.gototomb.attack(attack)
	if weapon_shots==1 and attack==1 then
		id=holzchopf.gototomb.target
		tx=getplayerx(id)
		ty=getplayery(id)-1
		if collision(colplayer,tx,ty,1,1)~=0 then return end
		-- enable weapon switching
		useweapon(1)
		weapon_shots=weapon_shots+1
		-- teleport
		playerposition(0,tx,ty)
		-- effects
		playsound(holzchopf.gototomb.sfx_att)
		for i=1,2,1 do
			if i==1 then
				x=getplayerx(0)
				y=getplayery(0)+3
			else
				x=tx
				y=ty+3
			end
			particle(p_muzzle,x,y)
			particlesize(1,1)
			particlecolor(50,200,255)
			particlealpha(1.0)
			particlefadealpha(0.01)
			particle(p_muzzle,x,y)
			particlesize(1,3)
			particlecolor(50,200,255)
			particlealpha(1.0)
			particlefadealpha(0.02)
			particlerotation(0)
			for j=1,10,1 do
				particle(p_lightpuff,x-10.0+math.random()*20.0,y+math.random()*10.0)
				particlesize(3.0,3.0)
				particlecolor(50,200,255)
				particlespeed(0,math.random(1,3)*-1.0)
				particlefadealpha(0.01)
			end
		end
	end
end